package cn.iocoder.yudao.module.pay.service.wxprofitsharing;

import java.util.*;
import javax.validation.*;
import cn.iocoder.yudao.module.pay.controller.admin.wxprofitsharing.vo.*;
import cn.iocoder.yudao.module.pay.controller.app.divide.vo.DrawMoneyVO;
import cn.iocoder.yudao.module.pay.dal.dataobject.divide.DivideDO;
import cn.iocoder.yudao.module.pay.dal.dataobject.wxprofitsharing.WxProfitsharingDO;
import cn.iocoder.yudao.framework.common.pojo.PageResult;
import cn.iocoder.yudao.framework.common.pojo.PageParam;

/**
 * 微信分账记录 Service 接口
 *
 * @author 管理员
 */
public interface WxProfitsharingService {

    /**
     * 创建微信分账记录
     *
     * @param createReqVO 创建信息
     * @return 编号
     */
    Long createWxProfitsharing(@Valid WxProfitsharingSaveReqVO createReqVO);

    /**
     * 更新微信分账记录
     *
     * @param updateReqVO 更新信息
     */
    void updateWxProfitsharing(@Valid WxProfitsharingSaveReqVO updateReqVO);

    /**
     * 删除微信分账记录
     *
     * @param id 编号
     */
    void deleteWxProfitsharing(Long id);

    /**
     * 获得微信分账记录
     *
     * @param id 编号
     * @return 微信分账记录
     */
    WxProfitsharingDO getWxProfitsharing(Long id);

    /**
     * 获得微信分账记录分页
     *
     * @param pageReqVO 分页查询
     * @return 微信分账记录分页
     */
    PageResult<WxProfitsharingDO> getWxProfitsharingPage(WxProfitsharingPageReqVO pageReqVO);
    /**
     * 分账
     **/
    int startProfitsharing();

    /**
     * 分账结果
     **/
    int getDivideResult();


    /**
     * 提现（退款）
     */
    Boolean drawMoney( DrawMoneyVO drawMoneyVO);

    /**
     * 分账回退
     */
    void returnMoney(Long payWxOrderId,int returnMoney);
}